#include "Inkey.ch"
#include "xMnu.ch"
#include "Common.ch"

// Niz prekidnih funkcija
STATIC aIntFunc := {}

#define TYPE		1
#define BLOCK	 	2
#define INTERVAL	3
#define START		3
#define LAST		4
#define ACTIVE		5

STATIC nTic := 0.1, nStart

#command INTERRUPT FUNC <f> EVERY <n> 	=> AddIntFunc ("I", <{f}>, <n>)
#command INTERRUPT FUNC <f> AFTER <n> 	=> AddIntFunc ("S", <{f}>, <n>)
#command INTERRUPT FUNC <f> AT <n> 		=> AddIntFunc ("T", <{f}>, #<n>)


STATIC nSat:= 1


********************
* 
* DATUM:  9. 3.1995. 
* 
* NAZIV: MAIN
* 
* OPIS: Glavni program
* 
* 
********************

PROC Main
	LOCAL i

	SET COLOR TO w/n,,,,n/w
	SET CURSOR OFF
	USE Semaphor INDEX Semaphor NEW
	USE Adresar SHARED READONLY ALIAS Adr1 NEW
	USE AdrNew ALIAS Adr2 NEW

	CLS
	FOR I := 1 TO 24
		@ i,0 SAY Replicate("",79) COLOR "w+/n"
	NEXT

	WIN CREATE w POS 7,40,14,76
	WIN DISPLAY w

	SetPos (0,0)

	INTERRUPT FUNC ShowTime() EVERY nSat
	INTERRUPT FUNC ShowSec() EVERY 0.1
	INTERRUPT FUNC ShowMem() EVERY 2
	INTERRUPT FUNC TestSem() EVERY 1
	INTERRUPT FUNC CopyRec() EVERY 0.1
	INTERRUPT FUNC ShowRec() EVERY 0.1
	INTERRUPT FUNC MemPack() EVERY 3
	INTERRUPT FUNC ScrSaver() AFTER 10
	INTERRUPT FUNC Remainder() AT 22:22

	MENU CREATE m1 COLOR "w/b"
		MENU ADD m1 PROMPT "&Table browse" ACTION {|| Table() }
		MENU ADD m1 PROMPT "&Input values" ACTION {|| Input() }
		MENU ADD m1
		MENU ADD m1 PROMPT "E&xit        "

	MENU CREATE m2 COLOR "w/b"
		MENU ADD m2 PROMPT "&Interval " ACTION {|| Get("I") }
		MENU ADD m2 PROMPT "&Sat      " 
		MENU ADD m2 PROMPT "&Stoperica" 

	MENU CREATE m3 COLOR "w/b"
		MENU ADD m3 PROMPT "Semafor: ON " ACTION {|| SemON() }
		MENU ADD m3 PROMPT "Semafor: OFF" ACTION {|| SemOFF() }

	MENU CREATE m HORIZONTAL COLOR "w/b"
		MENU ADD m PROMPT "&FILE" ACTION m1
		MENU ADD m PROMPT "&SET" ACTION m2
		MENU ADD m PROMPT "&OTHER" ACTION m3

	MENU DO m

	WIN CLOSE w

	CLS
	CLOSE ALL

RETURN






********************
* 
* DATUM: 19. 4.1996. 
* 
* NAZIV: Table()
* 
* OPIS:  Pregled tabele
* 
* 
********************

PROC Table
	LOCAL Ch, TB, w, x1,y1,x2,y2

	WIN CREATE w POS 3,0,22,40
	WIN DISPLAY w
	GetCor (w, @x1, @y1, @x2, @y2)

	USE Adresar SHARED NEW

	TB := TBrowseDB (x1+1, y1+1, x2-1, y2-1)
	TB:addColumn (TBColumnNew ("", { || Ime } ))

	WHILE .T.

		// Cekaj taster
		TB:forceStable()
		Ch := xKey(0)

		DO CASE 

			CASE Ch == K_ESC ; EXIT
			CASE Ch == K_UP  ; TB : Up () 
			CASE Ch == K_DOWN	; TB : Down ()
			CASE Ch == K_LEFT ; TB : Left ()
			CASE Ch == K_RIGHT ; TB : Right ()
			CASE Ch == K_HOME ; TB : Home ()
			CASE Ch == K_END ; TB : End ()
			CASE Ch == K_PGUP ; TB : PageUp ()
			CASE Ch == K_PGDN ; TB : PageDown ()
   		CASE Ch == K_CTRL_PGDN ; TB:goBottom()
   		CASE Ch == K_CTRL_PGUP ; TB:goTop()
		END CASE
	END DO

	CLOSE Adresar

	WIN CLOSE w

RETURN




********************
* 
* DATUM: 19. 4.1996. 
* 
* NAZIV: Input()
* 
* OPIS:  Unos vrednosti
* 
* 
********************

PROC Input
	LOCAL w, x1, x2, y1, y2

	WIN CREATE w POS 6,0,15,40
	WIN DISPLAY w
	GetCor (w, @x1, @y1, @x2, @y2)

	Ime := Space(20)
	Prezime := SPace(20)
	Adresa := Space(20)
	Adresa2 := Space(20)
	Napomena := Space(20)
	Napomena2 := Space(20)
	Napomena3 := Space(20)

	SET CURSOR ON

	@ x1+1,y1+2 SAY "Ime......." GET Ime
	@ x1+2,y1+2 SAY "Prezime..." GET Prezime
	@ x1+3,y1+2 SAY "Adresa...." GET Adresa
	@ x1+4,y1+2 SAY "          " GET Adresa2
	@ x1+5,y1+2 SAY "Napomena.." GET Napomena
	@ x1+6,y1+2 SAY "          " GET Napomena2
	@ x1+7,y1+2 SAY "          " GET Napomena3
	READ

	SET CURSOR OFF

	WIN CLOSE w

RETURN


********************
* 
* DATUM: 11. 3.1992. 
* 
* NAZIV: xKey (N)
* 
* OPIS:  Nenadov Inkey
* 
* 
********************

FUNC xKey (nSec)
	STATIC nPrevTic := 0
	LOCAL Ch

	// INKEY ()
	IF nSec == NIL
		Ch := Inkey()
		IF Ch == 0 .OR. Abs(Seconds() - nPrevTic) >= nTic
			Interrupt() ; nPrevTic := Seconds()
		END IF

	// INKEY (7)
	ELSEIF nSec > 0
		nStart := Seconds()
		REPEAT 
			Ch := Inkey(Min(nTic,nSec))
			IF Ch == 0 .OR. Abs(Seconds() - nPrevTic) >= nTic
				Interrupt() ; nPrevTic := Seconds()
			END IF
		UNTIL Ch <> 0 .OR. Abs(Seconds()-nStart) >= nSec
	
	// INKEY (0)
	ELSE
		nStart := Seconds()
		REPEAT 
			Ch := Inkey(nTic)
			IF Ch == 0 .OR. Abs(Seconds() - nPrevTic) >= nTic
				Interrupt() ; nPrevTic := Seconds()
			END IF
		UNTIL Ch <> 0 
	END IF

RETURN Ch




********************
* 
* DATUM: 14. 4.1996. 
* 
* NAZIV: Interrupt ()
* 
* OPIS:  Obrada prekida
* 
* 
********************

STATIC PROC Interrupt 
	LOCAL nSec, i

	// Uzmi sistemsko vreme
	nSec := Seconds()

	FOR i := 1 TO Len(aIntFunc)
		
		// Ako vec nije aktivna...
		IF aIntFunc[i,ACTIVE] <> TRUE

			aIntFunc[i,ACTIVE] := TRUE

			// Prekidne funkcije
			IF aIntFunc[i,TYPE] == "I"

				IF aIntFunc[i,LAST] + aIntFunc[i,INTERVAL] <= nSec
					Eval (aIntFunc[i,BLOCK])
					aIntFunc[i,LAST] := nSec
				END IF

			// U odredjeno vreme
			ELSEIF aIntFunc[i,TYPE] == "T"

				// Da li treba izvrsiti funkciju?
				IF Abs(aIntFunc[i,START] - nSec) <= nTic
					Eval (aIntFunc[i,BLOCK])
				END IF

			// Screen saver funkcije
			ELSEIF aIntFunc[i,TYPE] == "S"

				// Da li treba izvrsiti funkciju?
				IF Abs(nSec - nStart) >= aIntFunc[i,START] 
					Eval (aIntFunc[i,BLOCK])
					nStart := Seconds()
				END IF
			END IF

			aIntFunc[i,ACTIVE] := FALSE

		END IF


	NEXT

RETURN



********************
* 
* DATUM: 14. 4.1996. 
* 
* NAZIV: AddIntFunc (cType, bFunc, x)
* 
* OPIS:  Dodaje funkciju u spisak prekidnih rutina
* 
* 
********************

STATIC PROC AddIntFunc (cType, bFunc, x)
	LOCAL nStart, n

	AAdd (aIntFunc, Array(5))
	n := Len(aIntFunc)
	aIntFunc[n,TYPE] := cType
	aIntFunc[n,LAST] := 0
	aIntFunc[n,BLOCK] := bFunc

	IF cType == "I"
		aIntFunc[n,INTERVAL] := x

	ELSEIF cType == "T"
		nStart := Val(Left(x,2))*3600 + Val(SubStr(x,4,2))*60 + Val(SubStr(x,7,2))
		aIntFunc[n,START] := nStart

	ELSEIF cType == "S"
		aIntFunc[n,INTERVAL] := x

	END IF

RETURN



********************
* 
* DATUM: 19. 4.1996. 
* 
* NAZIV: ShowTime
* 
* OPIS:  Ispisuje vreme
* 
* 
********************

PROC ShowTime
	LOCAL x, y

	DispBegin()
	x := row()
	y := col()
	@ 0,72 SAY Time()
	SetPos(x,y)
	DispEnd()

RETURN


********************
* 
* DATUM: 19. 4.1996. 
* 
* NAZIV: ShowSec
* 
* OPIS:  Ispisuje stopericu
* 
* 
********************

PROC ShowSec
	LOCAL x, y

	DispBegin()
	x := row()
	y := col()
	@ 8,42 SAY "SECONDS: " + Str(Seconds())
	SetPos(x,y)
	DispEnd()

RETURN


********************
* 
* DATUM: 19. 4.1996. 
* 
* NAZIV: ShowMem
* 
* OPIS:  Ispisuje memoriju
* 
* 
********************

PROC ShowMem
	LOCAL x, y

	DispBegin()
	x := row()
	y := col()
	@  9,42 SAY "MEMORY : " + Str(Memory(104),5,0)
	SetPos(x,y)
	DispEnd()

RETURN


********************
* 
* DATUM: 19. 4.1996. 
* 
* NAZIV: Get 
* 
* OPIS:  Podesavanje vrednosti
* 
* 
********************

PROC Get 

	SET CURSOR ON

	@ 24,0 
	@ 24,0 SAY "UNESI INTERVAL:" GET nTic PICTURE "999.99"
	READ
	@ 24,0 

	SET CURSOR OFF

RETURN


********************
* 
* DATUM: 19. 4.1996. 
* 
* NAZIV: SemON/OFF
* 
* OPIS:  
* 
* 
********************

PROC SemON
	Semaphor->(DBSeek("TEST_SEM"))
	Semaphor->s_active := TRUE
RETURN

PROC SemOFF
	Semaphor->(DBSeek("TEST_SEM"))
	Semaphor->s_active := FALSE
RETURN



********************
* 
* DATUM: 19. 4.1996. 
* 
* NAZIV: TestSem
* 
* OPIS:  Provera semafora
* 
* 
********************

PROC TestSem
	LOCAL x, y

	DispBegin()
	x := row()
	y := col()

	Semaphor->(DBSeek("TEST_SEM"))
	IF Semaphor->s_active
		@ 10,42 SAY "SEMAPHOR: ON" COLOR "w*/n"
	ELSE
		@ 10,42 SAY "            " 
	END IF

	SetPos(x,y)
	DispEnd()

RETURN



********************
* 
* DATUM: 19. 4.1996. 
* 
* NAZIV: CopyRec()
* 
* OPIS:  Kopira slogove
* 
* 
********************

PROC CopyRec

	IF Adr1->(Eof())
		Adr1->(DBGoTop())
	END IF

	Adr2->(DBAppend())
	Adr2->Ime := Adr1->Ime
	Adr1->(DBSkip())

RETURN


********************
* 
* DATUM: 19. 4.1996. 
* 
* NAZIV: MemPack
* 
* OPIS:  Poziva GC
* 
* 
********************

PROC MemPack
	LOCAL x, y

	DispBegin()
	x := row()
	y := col()

	Memory(-1)
	@ 12,42 SAY "MEMORY PACKING..." + Str(Seconds())

	SetPos(x,y)
	DispEnd()

RETURN


********************
* 
* DATUM: 19. 4.1996. 
* 
* NAZIV: ShowRec
* 
* OPIS:  Ispisuje podatke o bazi
* 
* 
********************

PROC ShowRec
	LOCAL x, y

	DispBegin()
	x := row()
	y := col()

	@ 11,42 SAY "ADRESAR II: " + Str(Adr2->(LastRec()))

	SetPos(x,y)
	DispEnd()

RETURN



********************
* 
* DATUM: 19. 4.1996. 
* 
* NAZIV: ScrSaver
* 
* OPIS:  Saver
* 
* 
********************

PROC ScrSaver
	LOCAL x, y, c

	c := SaveScreen (0,0,24,79)

	x := row()
	y := col()

	CLS
	xKey(0)

	SetPos(x,y)

	RestScreen (0,0,24,79,c)

RETURN


********************
* 
* DATUM: 19. 4.1996. 
* 
* NAZIV: Remainder
* 
* OPIS:  
* 
* 
********************

PROC Remainder
	?? Chr(7)
RETURN
